Vue.component("gate-or", {
  props: {
    A: {
      type: Boolean,
      default: false
    },
    B: {
      type: Boolean,
      default: false
    },
    x: {
      type: Number,
      default: 0
    },
    y: {
      type: Number,
      default: 0
    },
    stroke: {
      type: String,
      default: "black"
    },
    lh: {
      type: String,
      default: "01"
    },
  },
  data: function(){
    return {
      dx: 10,
      dy: 10
    }
  },
  computed: {
    logA: function(){
      if (this.lh === "01")
        return Boolean(this.A) ? "1" : "0";
      if (this.lh === "LH")
        return Boolean(this.A) ? "H" : "L";
      if (this.lh === "FT")
        return Boolean(this.A) ? "T" : "F";
    },
    logB: function(){
      if (this.lh === "01")
        return Boolean(this.B) ? "1" : "0";
      if (this.lh === "LH")
        return Boolean(this.B) ? "H" : "L";
      if (this.lh === "FT")
        return Boolean(this.B) ? "T" : "F";
    },
    Q: function(){
      return (Boolean(this.A) || Boolean(this.B));
    },
    logQ: function(){
      if (this.lh === "01")
        return this.Q ? "1" : "0";
      if (this.lh === "LH")
        return this.Q ? "H" : "L";
      if (this.lh === "FT")
        return this.Q ? "T" : "F";
    },
    transform: function(){
      return "translate(" + (this.x * this.dx) + ", " + (this.y * this.dy) +") ";
    }
  },
  template: '<g transform="scale(2)"><g :stroke="stroke" :transform="transform" ><path d="M 20, 0 l 40, 0 l 0, 60 l -40, 0 l 0, -60 M 0 0 M 0 10 l 20 0 M 0 50 l 20 0 M 60 30 l 20 0 " :stroke="stroke" fill="white" /><text x="10" y="7" font-size="12" text-anchor="middle" >{{logA}}</text><text x="10" y="47" font-size="12" text-anchor="middle" >{{logB}}</text><text x="75" y="27" font-size="12" text-anchor="middle" >{{logQ}}</text><text x="50" y="15" font-size="12" text-anchor="middle" >&ge;1</text></g></g>'
});



Vue.component("gate-nor", {
  props: {
    A: {
      type: Boolean,
      default: false
    },
    B: {
      type: Boolean,
      default: false
    },
    x: {
      type: Number,
      default: 0
    },
    y: {
      type: Number,
      default: 0
    },
    stroke: {
      type: String,
      default: "black"
    },
    lh: {
      type: String,
      default: "01"
    },
  },
  data: function(){
    return {
      dx: 10,
      dy: 10
    }
  },
  computed: {
    logA: function(){
      if (this.lh === "01")
        return Boolean(this.A) ? "1" : "0";
      if (this.lh === "LH")
        return Boolean(this.A) ? "H" : "L";
      if (this.lh === "FT")
        return Boolean(this.A) ? "T" : "F";
    },
    logB: function(){
      if (this.lh === "01")
        return Boolean(this.B) ? "1" : "0";
      if (this.lh === "LH")
        return Boolean(this.B) ? "H" : "L";
      if (this.lh === "FT")
        return Boolean(this.B) ? "T" : "F";
    },
    Q: function(){
      return !(Boolean(this.A) || Boolean(this.B));
    },
    logQ: function(){
      if (this.lh === "01")
        return this.Q ? "1" : "0";
      if (this.lh === "LH")
        return this.Q ? "H" : "L";
      if (this.lh === "FT")
        return this.Q ? "T" : "F";
    },
    transform: function(){
      return "translate(" + (this.x * this.dx) + ", " + (this.y * this.dy) +") ";
    }
  },
  template: '<g transform="scale(2)"><g :stroke="stroke" :transform="transform" ><path d="M 20, 0 l 40, 0 l 0, 60 l -40, 0 l 0, -60 M 0 0 M 0 10 l 20 0 M 0 50 l 20 0 M 65 30 m -5 0 a 5 5 0 1 0 10 0 a 5 5 0 1 0 -10 0 M 70 30 l 10 0   " :stroke="stroke" fill="white" /><text x="10" y="7" font-size="12" text-anchor="middle" >{{logA}}</text><text x="10" y="47" font-size="12" text-anchor="middle" >{{logB}}</text><text x="75" y="27" font-size="12" text-anchor="middle" >{{logQ}}</text><text x="50" y="15" font-size="12" text-anchor="middle" >&ge;1</text></g></g>'
});




Vue.component("gate-and", {
  props: {
    A: {
      type: Boolean,
      default: false
    },
    B: {
      type: Boolean,
      default: false
    },
    x: {
      type: Number,
      default: 0
    },
    y: {
      type: Number,
      default: 0
    },
    stroke: {
      type: String,
      default: "black"
    },
    lh: {
      type: String,
      default: "01"
    },
  },
  data: function(){
    return {
      dx: 10,
      dy: 10
    }
  },
  computed: {
    logA: function(){
      if (this.lh === "01")
        return Boolean(this.A) ? "1" : "0";
      if (this.lh === "LH")
        return Boolean(this.A) ? "H" : "L";
      if (this.lh === "FT")
        return Boolean(this.A) ? "T" : "F";
    },
    logB: function(){
      if (this.lh === "01")
        return Boolean(this.B) ? "1" : "0";
      if (this.lh === "LH")
        return Boolean(this.B) ? "H" : "L";
      if (this.lh === "FT")
        return Boolean(this.B) ? "T" : "F";
    },
    Q: function(){
      return (Boolean(this.A) && Boolean(this.B));
    },
    logQ: function(){
      if (this.lh === "01")
        return this.Q ? "1" : "0";
      if (this.lh === "LH")
        return this.Q ? "H" : "L";
      if (this.lh === "FT")
        return this.Q ? "T" : "F";
    },
    transform: function(){
      return "translate(" + (this.x * this.dx) + ", " + (this.y * this.dy) +") ";
    }
  },
  template: '<g transform="scale(2)"><g :stroke="stroke" :transform="transform" ><path d="M 20, 0 l 40, 0 l 0, 60 l -40, 0 l 0, -60 M 0 0 M 0 10 l 20 0 M 0 50 l 20 0 M 60 30 l 20 0 " :stroke="stroke" fill="white" /><text x="10" y="7" font-size="12" text-anchor="middle" >{{logA}}</text><text x="10" y="47" font-size="12" text-anchor="middle" >{{logB}}</text><text x="75" y="27" font-size="12" text-anchor="middle" >{{logQ}}</text><text x="50" y="15" font-size="12" text-anchor="middle" >&amp;</text></g></g>'
});




Vue.component("gate-nand", {
  props: {
    A: {
      type: Boolean,
      default: false
    },
    B: {
      type: Boolean,
      default: false
    },
    x: {
      type: Number,
      default: 0
    },
    y: {
      type: Number,
      default: 0
    },
    stroke: {
      type: String,
      default: "black"
    },
    lh: {
      type: String,
      default: "01"
    },
  },
  data: function(){
    return {
      dx: 10,
      dy: 10
    }
  },
  computed: {
    logA: function(){
      if (this.lh === "01")
        return Boolean(this.A) ? "1" : "0";
      if (this.lh === "LH")
        return Boolean(this.A) ? "H" : "L";
      if (this.lh === "FT")
        return Boolean(this.A) ? "T" : "F";
    },
    logB: function(){
      if (this.lh === "01")
        return Boolean(this.B) ? "1" : "0";
      if (this.lh === "LH")
        return Boolean(this.B) ? "H" : "L";
      if (this.lh === "FT")
        return Boolean(this.B) ? "T" : "F";
    },
    Q: function(){
      return !(Boolean(this.A) && Boolean(this.B));
    },
    logQ: function(){
      if (this.lh === "01")
        return this.Q ? "1" : "0";
      if (this.lh === "LH")
        return this.Q ? "H" : "L";
      if (this.lh === "FT")
        return this.Q ? "T" : "F";
    },
    transform: function(){
      return "translate(" + (this.x * this.dx) + ", " + (this.y * this.dy) +") ";
    }
  },
  template: '<g transform="scale(2)"><g :stroke="stroke" :transform="transform" ><path d="M 20, 0 l 40, 0 l 0, 60 l -40, 0 l 0, -60 M 0 0 M 0 10 l 20 0 M 0 50 l 20 0 M 65 30 m -5 0 a 5 5 0 1 0 10 0 a 5 5 0 1 0 -10 0 M 70 30 l 10 0   " :stroke="stroke" fill="white" /><text x="10" y="7" font-size="12" text-anchor="middle" >{{logA}}</text><text x="10" y="47" font-size="12" text-anchor="middle" >{{logB}}</text><text x="75" y="27" font-size="12" text-anchor="middle" >{{logQ}}</text><text x="50" y="15" font-size="12" text-anchor="middle" >&amp;</text></g></g>'
});




Vue.component("gate-xor", {
  props: {
    A: {
      type: Boolean,
      default: false
    },
    B: {
      type: Boolean,
      default: false
    },
    x: {
      type: Number,
      default: 0
    },
    y: {
      type: Number,
      default: 0
    },
    stroke: {
      type: String,
      default: "black"
    },
    lh: {
      type: String,
      default: "01"
    },
  },
  data: function(){
    return {
      dx: 10,
      dy: 10
    }
  },
  computed: {
    logA: function(){
      if (this.lh === "01")
        return Boolean(this.A) ? "1" : "0";
      if (this.lh === "LH")
        return Boolean(this.A) ? "H" : "L";
      if (this.lh === "FT")
        return Boolean(this.A) ? "T" : "F";
    },
    logB: function(){
      if (this.lh === "01")
        return Boolean(this.B) ? "1" : "0";
      if (this.lh === "LH")
        return Boolean(this.B) ? "H" : "L";
      if (this.lh === "FT")
        return Boolean(this.B) ? "T" : "F";
    },
    Q: function(){
      return (Boolean(this.A) != Boolean(this.B));
    },
    logQ: function(){
      if (this.lh === "01")
        return this.Q ? "1" : "0";
      if (this.lh === "LH")
        return this.Q ? "H" : "L";
      if (this.lh === "FT")
        return this.Q ? "T" : "F";
    },
    transform: function(){
      return "translate(" + (this.x * this.dx) + ", " + (this.y * this.dy) +") ";
    }
  },
  template: '<g transform="scale(2)"><g :stroke="stroke" :transform="transform" ><path d="M 20, 0 l 40, 0 l 0, 60 l -40, 0 l 0, -60 M 0 0 M 0 10 l 20 0 M 0 50 l 20 0 M 60 30 l 20 0 " :stroke="stroke" fill="white" /><text x="10" y="7" font-size="12" text-anchor="middle" >{{logA}}</text><text x="10" y="47" font-size="12" text-anchor="middle" >{{logB}}</text><text x="75" y="27" font-size="12" text-anchor="middle" >{{logQ}}</text><text x="50" y="15" font-size="12" text-anchor="middle" >=1</text></g></g>'
});




Vue.component("gate-xnor", {
  props: {
    A: {
      type: Boolean,
      default: false
    },
    B: {
      type: Boolean,
      default: false
    },
    x: {
      type: Number,
      default: 0
    },
    y: {
      type: Number,
      default: 0
    },
    stroke: {
      type: String,
      default: "black"
    },
    lh: {
      type: String,
      default: "01"
    },
  },
  data: function(){
    return {
      dx: 10,
      dy: 10
    }
  },
  computed: {
    logA: function(){
      if (this.lh === "01")
        return Boolean(this.A) ? "1" : "0";
      if (this.lh === "LH")
        return Boolean(this.A) ? "H" : "L";
      if (this.lh === "FT")
        return Boolean(this.A) ? "T" : "F";
    },
    logB: function(){
      if (this.lh === "01")
        return Boolean(this.B) ? "1" : "0";
      if (this.lh === "LH")
        return Boolean(this.B) ? "H" : "L";
      if (this.lh === "FT")
        return Boolean(this.B) ? "T" : "F";
    },
    Q: function(){
      return (Boolean(this.A) == Boolean(this.B));
    },
    logQ: function(){
      if (this.lh === "01")
        return this.Q ? "1" : "0";
      if (this.lh === "LH")
        return this.Q ? "H" : "L";
      if (this.lh === "FT")
        return this.Q ? "T" : "F";
    },
    transform: function(){
      return "translate(" + (this.x * this.dx) + ", " + (this.y * this.dy) +") ";
    }
  },
  template: '<g transform="scale(2)"><g :stroke="stroke" :transform="transform" ><path d="M 20, 0 l 40, 0 l 0, 60 l -40, 0 l 0, -60 M 0 0 M 0 10 l 20 0 M 0 50 l 20 0 M 65 30 m -5 0 a 5 5 0 1 0 10 0 a 5 5 0 1 0 -10 0 M 70 30 l 10 0   " :stroke="stroke" fill="white" /><text x="10" y="7" font-size="12" text-anchor="middle" >{{logA}}</text><text x="10" y="47" font-size="12" text-anchor="middle" >{{logB}}</text><text x="75" y="27" font-size="12" text-anchor="middle" >{{logQ}}</text><text x="50" y="15" font-size="12" text-anchor="middle" >=1</text></g></g>'
});